Summary: A mouse server for the Linux console.
Name: gpm

%global momorel 1

Version: 1.20.1
Release: %{momorel}m
License: GPL
Group: System Environment/Daemons

%NoSource 0 http://ftp.linux.it/pub/People/rubini/gpm/gpm-1.20.1.tar.bz2 2c63e827d755527950d9d13fe3d87692
Source1: gpm.init
Patch1: gpm-evdev-cumulative.patch
Patch2: gpm-1.20.1-math.patch
Patch3: gpm-1.20.1-weak-wgetch.patch
Patch4: gpm-1.20.1-nodebug.patch
Patch5: gpm-1.20.1-gpmopen.patch
Patch6: gpm-1.20.1-idie.patch
Patch16: gpm-1.20.1-subscript.patch
Patch17: gpm-1.20.1-input.patch
Patch18: gpm-1.20.1-consolename.patch
Patch19: gpm-1.20.1-multilib.patch

# this defines the library version that this package builds.
%define LIBVER 1.19.0
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: emacs
BuildPreReq: ncurses-devel >= 5.4
BuildPrereq: sed gawk texinfo bison

Prereq: chkconfig glibc info

%description
Gpm provides mouse support to text-based Linux applications like the
Emacs editor and the Midnight Commander file management system.  Gpm
also provides console cut-and-paste operations using the mouse and
includes a program to allow pop-up menus to appear at the click of a
mouse button.


%package devel
Requires: %{name} = %{version}
Summary: A mouse server for the Linux console.
Group: System Environment/Daemons

%description devel
Gpm provides mouse support to text-based Linux applications like the
Emacs editor and the Midnight Commander file management system.  Gpm
also provides console cut-and-paste operations using the mouse and
includes a program to allow pop-up menus to appear at the click of a
mouse button.


%prep
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%setup -q
%patch1 -p1 -b .evdev
%patch2 -p1 -b .math
%patch3 -p1 -b .weak-wgetch
%patch4 -p1 -b .nodebug
%patch5 -p1 -b .gpmopen
%patch6 -p1 -b .idie
%patch16 -p1 -b .subscript
%patch17 -p1 -b .input
%patch18 -p1 -b .consolename
%patch19 -p1 -b .multilib

%build
autoconf
CFLAGS="-D_GNU_SOURCE %{optflags}" \
    lispdir=%{buildroot}%{_datadir}/emacs/site-lisp \
    %configure
make

%install
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}
%__mkdir_p %{buildroot}%{_sysconfdir}

PATH=/sbin:$PATH:/usr/sbin:$PATH

%__mkdir_p %{buildroot}%{_datadir}/emacs/site-lisp
%makeinstall lispdir=%{buildroot}%{_datadir}/emacs/site-lisp

%__install -m 644 doc/gpm-root.1 %{buildroot}%{_mandir}/man1
%__install -m 644 conf/gpm-root.conf %{buildroot}%{_sysconfdir}
%__install -s -m 755 src/prog/hltest %{buildroot}%{_bindir}

cp contrib/emacs/t-mouse.el* %{buildroot}%{_datadir}/emacs/site-lisp

{
  pushd %{buildroot}
  %__chmod +x .%{_libdir}/libgpm.so.%{LIBVER}
  %__ln_s -f libgpm.so.%{LIBVER} .%{_libdir}/libgpm.so
  /sbin/ldconfig -n .%{_libdir}
  popd
}

%__mkdir_p %{buildroot}%{_initscriptdir}
%__install -m 755 $RPM_SOURCE_DIR/gpm.init %{buildroot}%{_initscriptdir}/gpm

%__mkdir_p %{buildroot}%{_sysconfdir}/sysconfig
#%%__cat > %{buildroot}%{_sysconfdir}/sysconfig/gpm <<EOF
## Additional options for gpm (e.g. acceleration), device
#OPTIONS=""
#DEVICE="/dev/mouse"
#EOF

# remove stuff from the buildroot that we aren't shipping
rm -f %{buildroot}%{_bindir}/disable-paste
rm -f %{buildroot}%{_mandir}/man1/mouse-test.1*

%clean
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%post
/sbin/chkconfig --add gpm
/sbin/ldconfig
/sbin/install-info %{_infodir}/gpm.info.* %{_infodir}/dir

%preun
if [ $1 = 0 ]; then
  /sbin/install-info %{_infodir}/gpm.info.* --delete %{_infodir}/dir
  service gpm stop >/dev/null 2>&1
  /sbin/chkconfig --del gpm
fi

%postun
/sbin/ldconfig
if [ "$1" -ge "1" ]; then
  service gpm condrestart >/dev/null 2>&1
fi
/sbin/ldconfig

%files
%defattr(-,root,root)
%config %{_sysconfdir}/gpm-root.conf
%config %{_initscriptdir}/gpm
%{_bindir}/mev
%{_bindir}/gpm-root
%{_bindir}/hltest
%{_bindir}/mouse-test
%{_mandir}/man1/mev.1*
%{_mandir}/man1/gpm-root*
%{_mandir}/man7/gpm-types*
%{_mandir}/man8/gpm*
/usr/sbin/gpm
%{_datadir}/emacs/site-lisp/t-mouse.el*
%{_infodir}/gpm.info*
%{_libdir}/libgpm.so.*

%files devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/libgpm.a
%{_libdir}/libgpm.so

%changelog
* Fri Mar 11 2005 Toru Hoshina <t@momonga-linux.org>
- (1.20.1-1m)
- ver up. sync with FC3(1.20.1-66).

* Wed Mar  9 2005 Toru Hoshina <t@momonga-linux.org>
- (1.19.3-20m)
- rebuild against ncurses-5.4-1m.

* Tue Oct 19 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.19.3-19m)
- add Patch11: gpm-1.19.3-gcc34.patch
  reported by Hiromasa YOSHIMOTO [Momonga-devel.ja:02823]

* Mon Aug 30 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (1.19.3-18m)
- changed to use libncurses.so instead of libncurses.a for prelink

* Sat Jul  3 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.19.3-17m)
- stop daemon

* Sat Mar 20 2004 Toru Hoshina <t@momonga-linux.org>
- (1.19.3-16m)
- revised spec for enabling rpm 4.2.

* Mon Oct 27 2003 Kenta MURATA <muraken2@nifty.com>
- (1.19.3-15m)
- pretty spec file.

* Tue Jul 23 2002 Masahiro Takahata <takahata@momonga-linux.org>
- (1.19.3-15m)
- import patches from rawhide
- include source file

* Tue Nov 28 2000 Toru Hoshina <toru@df-usa.com>
- use _initscriptdir macro to keep backword compatibility.

* Wed Oct 25 2000 MATSUDA, Daiki <dyky@df-usa.com>
- modifiled %post and %preun section from .gz to .bz2

* Tue Oct 17 2000 Hidetomo Machi <mcHT@kondara.org>
- add %doc section
- move t-mouse.{el,elc} to %doc
  (Don't install under /usr/share/emacs/site-lisp in package)

* Wed Jul 26 2000 Preston Brown <pbrown@redhat.com>
- clarification: pam requirement added to fix permissions on /dev/gpmctl (#12849)

* Sat Jul 22 2000 Florian La Roche <Florian.LaRoche@redhat.de>
- update to 1.19.3

* Sat Jul 15 2000 Bill Nottingham <notting@redhat.com>
- move initscript back

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Fri Jun 30 2000 Matt Wilson <msw@redhat.com>
- use sysconf(_SC_OPEN_MAX)

* Tue Jun 27 2000 Preston Brown <pbrown@redhat.com>
- don't prereq, only require initscripts

* Mon Jun 26 2000 Preston Brown <pbrown@redhat.com>
- fix up and move initscript
- prereq initscripts >= 5.20

* Sat Jun 17 2000 Bill Nottingham <notting@redhat.com>
- fix %config tag for initscript

* Thu Jun 15 2000 Bill Nottingham <notting@redhat.com>
- move it back

* Thu Jun 15 2000 Preston Brown <pbrown@redhat.com>
- move init script

* Wed Jun 14 2000 Preston Brown <pbrown@redhat.com>
- security patch on socket descriptor from Chris Evans.  Thanks Chris.
- include limits.h for OPEN_MAX

* Mon Jun 12 2000 Preston Brown <pbrown@redhat.com>
- 1.19.2, fix up root (setuid) patch
- FHS paths

* Thu Apr  6 2000 Jakub Jelinek <jakub@redhat.com>
- 1.19.1
- call initgroups in gpm-root before spawning command as user
- make gpm-root work on big endian

* Sun Mar 26 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- call ldconfig directly in postun

* Wed Mar 22 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild with new libncurses

* Sat Mar 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.19.0
- fix build on systems that don't have emacs
  (configure built t-mouse* only if emacs was installed)

* Tue Feb 29 2000 Preston Brown <pbrown@redhat.com>
- important fix: improperly buildrooted for /usr/share/emacs/site-lisp, fixed.

* Tue Feb 15 2000 Jakub Jelinek <jakub@redhat.com>
- avoid cluttering of syslog with gpm No data messages

* Mon Feb 14 2000 Preston Brown <pbrown@redhat.com>
- disable-paste and mouse-test removed, they seem broken.

* Thu Feb 03 2000 Preston Brown <pbrown@redhat.com>
- updated gpm.init to have better shutdown and descriptive messages
- strip lib

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- fix description
- man pages are compressed

* Wed Jan 12 2000 Preston Brown <pbrown@redhat.com>
- 1.18.1.

* Tue Sep 28 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 1.18, hopefully fixes sparc protocol issues

* Fri Sep 24 1999 Bill Nottingham <notting@redhat.com>
- install-info sucks, and then you die.

* Fri Sep 10 1999 Bill Nottingham <notting@redhat.com>
- chkconfig --del in %preun, not %postun

* Fri Aug 27 1999 Preston Brown <pbrown@redhat.com>
- upgrade to 1.17.9
- the maintainers are taking care of .so version now, removed patch

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging

* Wed Jun  2 1999 Jeff Johnson <jbj@redhat.com>
- disable-paste need not be setuid root in Red Hat 6.0 (#2654)

* Tue May 18 1999 Michael K. Johnson <johnsonm@redhat.com>
- gpm.init had wrong pidfile name in comments; confused linuxconf

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- make sure all binaries are stripped, make init stuff more chkconfig style
- removed sparc-specific mouse stuff
- bumped libver to 1.17.5
- fixed texinfo source

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Thu Mar  4 1999 Matt Wilson <msw@redhat.com>
- updated to 1.75.5

* Tue Feb 16 1999 Cristian Gafton <gafton@redhat.com>
- avoid using makedev for internal functions (it is a #define in the system
  headers)

* Wed Jan 13 1999 Preston Brown <pbrown@redhat.com>
- upgrade to 1.17.2.

* Wed Jan 06 1999 Cristian Gafton <gafton@redhat.com>
- enforce the use of -D_GNU_SOURCE so that it will compile on the ARM
- build against glibc 2.1

* Tue Aug 11 1998 Jeff Johnson <jbj@redhat.com>
- build root

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Apr 22 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhanced initscript

* Fri Apr 10 1998 Cristian Gafton <gafton@redhat.com>
- recompiled for manhattan

* Wed Apr 08 1998 Erik Troan <ewt@redhat.com>
- updated to 1.13

* Mon Nov 03 1997 Donnie Barnes <djb@redhat.com>
- added patch from Richard to get things to build on the SPARC

* Tue Oct 28 1997 Donnie Barnes <djb@redhat.com>
- fixed the emacs patch to install the emacs files in the right
  place (hopefully).

* Mon Oct 13 1997 Erik Troan <ewt@redhat.com>
- added chkconfig support
- added install-info

* Thu Sep 11 1997 Donald Barnes <djb@redhat.com>
- upgraded from 1.10 to 1.12
- added status/restart functionality to init script
- added define LIBVER 1.11

* Thu Jun 19 1997 Erik Troan <ewt@redhat.com>
- built against glibc
